--    Program: 		CAPAREXT_INVOICE_LINE.sql
--    Description:  Extract AR Invoice Line information 
--    Revision:     1st     
--    Parameter: 	1. set of books short name e.g. SOB_C999

set doc off;      
set verify off;
set serveroutput on size 1000000;
whenever sqlerror exit failure rollback;
alter session set nls_date_format='YYYYMMDD HH24:MI:SS';

declare   
   l_processed_count		number;
   l_rejected_count 		number;
   l_err_msg				varchar2(2000);
                    		
   l_utl_file       		utl_file.file_type;
   l_filename       		varchar2(255);
   l_pathname       		varchar2(100);
                    		
   l_ngo_sob				varchar2(20);
   
   l_set_of_books_id		number;
                    		  
   cursor cur_invoice_line (p_set_of_books_id number) is
      select * from ra_customer_trx_lines_all
      where set_of_books_id = p_set_of_books_id;

begin
   l_pathname := '/tmp';
   l_filename := 'CAPAR_INVOICE_LINE.dat';
   l_utl_file := utl_file.fopen(l_pathname, l_filename, 'w');
   
   l_processed_count := 0;
   l_rejected_count  := 0;
   
   l_ngo_sob := '&1';
   
   begin
     select set_of_books_id
     into   l_set_of_books_id
     from   gl_sets_of_books
     where  upper(short_name) = upper(l_ngo_sob);
   exception
     when others then
       dbms_output.put_line(l_ngo_sob||': set of books name not found');
       --raise;
   end;      

   for cur in cur_invoice_line(l_set_of_books_id) loop   	
     
     -- output data 
     utl_file.put_line( l_utl_file, 
       cur.CUSTOMER_TRX_LINE_ID            || chr(9) ||
       cur.LAST_UPDATE_DATE                || chr(9) ||
       cur.LAST_UPDATED_BY                 || chr(9) ||
       cur.CREATION_DATE                   || chr(9) ||
       cur.CREATED_BY                      || chr(9) ||
       cur.LAST_UPDATE_LOGIN               || chr(9) ||
       cur.CUSTOMER_TRX_ID                 || chr(9) ||
       cur.LINE_NUMBER                     || chr(9) ||
       cur.SET_OF_BOOKS_ID                 || chr(9) ||
       cur.REASON_CODE                     || chr(9) ||
       cur.INVENTORY_ITEM_ID               || chr(9) ||
       replace(cur.DESCRIPTION, chr(10), '||') || chr(9) ||
       cur.PREVIOUS_CUSTOMER_TRX_ID        || chr(9) ||
       cur.PREVIOUS_CUSTOMER_TRX_LINE_ID   || chr(9) ||
       cur.QUANTITY_ORDERED                || chr(9) ||
       cur.QUANTITY_CREDITED               || chr(9) ||
       cur.QUANTITY_INVOICED               || chr(9) ||
       cur.UNIT_STANDARD_PRICE             || chr(9) ||
       cur.UNIT_SELLING_PRICE              || chr(9) ||
       cur.SALES_ORDER                     || chr(9) ||
       cur.SALES_ORDER_REVISION            || chr(9) ||
       cur.SALES_ORDER_LINE                || chr(9) ||
       cur.SALES_ORDER_DATE                || chr(9) ||
       cur.ACCOUNTING_RULE_ID              || chr(9) ||
       cur.ACCOUNTING_RULE_DURATION        || chr(9) ||
       cur.LINE_TYPE                       || chr(9) ||
       cur.ATTRIBUTE_CATEGORY              || chr(9) ||
       cur.ATTRIBUTE1                      || chr(9) ||
       cur.ATTRIBUTE2                      || chr(9) ||
       cur.ATTRIBUTE3                      || chr(9) ||
       cur.ATTRIBUTE4                      || chr(9) ||
       cur.ATTRIBUTE5                      || chr(9) ||
       cur.ATTRIBUTE6                      || chr(9) ||
       cur.ATTRIBUTE7                      || chr(9) ||
       cur.ATTRIBUTE8                      || chr(9) ||
       cur.ATTRIBUTE9                      || chr(9) ||
       cur.ATTRIBUTE10                     || chr(9) ||
       cur.REQUEST_ID                      || chr(9) ||
       cur.PROGRAM_APPLICATION_ID          || chr(9) ||
       cur.PROGRAM_ID                      || chr(9) ||
       cur.PROGRAM_UPDATE_DATE             || chr(9) ||
       cur.RULE_START_DATE                 || chr(9) ||
       cur.INITIAL_CUSTOMER_TRX_LINE_ID    || chr(9) ||
       cur.INTERFACE_LINE_CONTEXT          || chr(9) ||
       cur.INTERFACE_LINE_ATTRIBUTE1       || chr(9) ||
       cur.INTERFACE_LINE_ATTRIBUTE2       || chr(9) ||
       cur.INTERFACE_LINE_ATTRIBUTE3       || chr(9) ||
       cur.INTERFACE_LINE_ATTRIBUTE4       || chr(9) ||
       cur.INTERFACE_LINE_ATTRIBUTE5       || chr(9) ||
       cur.INTERFACE_LINE_ATTRIBUTE6       || chr(9) ||
       cur.INTERFACE_LINE_ATTRIBUTE7       || chr(9) ||
       cur.INTERFACE_LINE_ATTRIBUTE8       || chr(9) ||
       cur.SALES_ORDER_SOURCE              || chr(9) ||
       cur.TAXABLE_FLAG                    || chr(9) ||
       cur.EXTENDED_AMOUNT                 || chr(9) ||
       cur.REVENUE_AMOUNT                  || chr(9) ||
       cur.AUTORULE_COMPLETE_FLAG          || chr(9) ||
       cur.LINK_TO_CUST_TRX_LINE_ID        || chr(9) ||
       cur.ATTRIBUTE11                     || chr(9) ||
       cur.ATTRIBUTE12                     || chr(9) ||
       cur.ATTRIBUTE13                     || chr(9) ||
       cur.ATTRIBUTE14                     || chr(9) ||
       cur.ATTRIBUTE15                     || chr(9) ||
       cur.TAX_PRECEDENCE                  || chr(9) ||
       cur.TAX_RATE                        || chr(9) ||
       cur.ITEM_EXCEPTION_RATE_ID          || chr(9) ||
       cur.TAX_EXEMPTION_ID                || chr(9) ||
       cur.MEMO_LINE_ID                    || chr(9) ||
       cur.AUTORULE_DURATION_PROCESSED     || chr(9) ||
       cur.UOM_CODE                        || chr(9) ||
       cur.DEFAULT_USSGL_TRANSACTION_CODE  || chr(9) ||
       cur.DEFAULT_USSGL_TRX_CODE_CONTEXT  || chr(9) ||
       cur.INTERFACE_LINE_ATTRIBUTE10      || chr(9) ||
       cur.INTERFACE_LINE_ATTRIBUTE11      || chr(9) ||
       cur.INTERFACE_LINE_ATTRIBUTE12      || chr(9) ||
       cur.INTERFACE_LINE_ATTRIBUTE13      || chr(9) ||
       cur.INTERFACE_LINE_ATTRIBUTE14      || chr(9) ||
       cur.INTERFACE_LINE_ATTRIBUTE15      || chr(9) ||
       cur.INTERFACE_LINE_ATTRIBUTE9       || chr(9) ||
       cur.VAT_TAX_ID                      || chr(9) ||
       cur.AUTOTAX                         || chr(9) ||
       cur.LAST_PERIOD_TO_CREDIT           || chr(9) ||
       cur.ITEM_CONTEXT                    || chr(9) ||
       cur.TAX_EXEMPT_FLAG                 || chr(9) ||
       cur.TAX_EXEMPT_NUMBER               || chr(9) ||
       cur.TAX_EXEMPT_REASON_CODE          || chr(9) ||
       cur.TAX_VENDOR_RETURN_CODE          || chr(9) ||
       cur.SALES_TAX_ID                    || chr(9) ||
       cur.LOCATION_SEGMENT_ID             || chr(9) ||
       cur.MOVEMENT_ID                     || chr(9) ||
       cur.ORG_ID                          || chr(9) ||
       cur.WH_UPDATE_DATE                  || chr(9) ||
       cur.GLOBAL_ATTRIBUTE1               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE2               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE3               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE4               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE5               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE6               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE7               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE8               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE9               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE10              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE11              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE12              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE13              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE14              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE15              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE16              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE17              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE18              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE19              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE20              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE_CATEGORY       || chr(9) ||
       cur.GROSS_UNIT_SELLING_PRICE        || chr(9) ||
       cur.GROSS_EXTENDED_AMOUNT           || chr(9) ||
       cur.AMOUNT_INCLUDES_TAX_FLAG        || chr(9) ||
       cur.TAXABLE_AMOUNT                  || chr(9) ||
       cur.WAREHOUSE_ID                    || chr(9) ||
       cur.TRANSLATED_DESCRIPTION          || chr(9) ||
       cur.EXTENDED_ACCTD_AMOUNT           || chr(9) ||
       cur.BR_REF_CUSTOMER_TRX_ID          || chr(9) ||
       cur.BR_REF_PAYMENT_SCHEDULE_ID      || chr(9) ||
       cur.BR_ADJUSTMENT_ID                || chr(9) ||
       cur.MRC_EXTENDED_ACCTD_AMOUNT       || chr(9) ||
       cur.PAYMENT_SET_ID                  || chr(9) ||
       cur.CONTRACT_LINE_ID                || chr(9) ||
       cur.SOURCE_DATA_KEY1                || chr(9) ||
       cur.SOURCE_DATA_KEY2                || chr(9) ||
       cur.SOURCE_DATA_KEY3                || chr(9) ||
       cur.SOURCE_DATA_KEY4                || chr(9) ||
       cur.SOURCE_DATA_KEY5                || chr(9) ||
       cur.INVOICED_LINE_ACCTG_LEVEL
	 );                        
                               
	 l_processed_count := l_processed_count + 1;
   end loop;

   if l_processed_count = 0 then   
     l_rejected_count := l_rejected_count + 1;
     l_err_msg := l_ngo_sob || ': AR Invoice Line not found';
   end if;
   
   -- insert into log table
   insert into capcnv_log ( prog_id,process_date, record_processed,record_rejected,record_extracted,err_msg) 
    values ('CAPAREXT_INVOICE_LINE', sysdate, l_processed_count, l_rejected_count, l_processed_count-l_rejected_count, l_err_msg );
   
   commit;

   utl_file.fclose(l_utl_file);
exception 
  when others then
    dbms_output.put_line(sqlerrm);
    rollback;  
end;
/

--exit
